%define DATE 20041214
%define gcc_version 4.0.0
%define gcc_release 0.14.EL4
%define _unpackaged_files_terminate_build 0
%define multilib_64_archs sparc64 ppc64 s390x x86_64
%define gxx_primary_version 3.4.3
%ifarch s390x
%define multilib_32_arch s390
%endif
%ifarch sparc64
%define multilib_32_arch sparc
%endif
%ifarch ppc64
%define multilib_32_arch ppc
%endif
%ifarch x86_64
%define multilib_32_arch i386
%endif
Summary: Preview of GCC version 4.0
Name: gcc4
Version: %{gcc_version}
Release: %{gcc_release}
Copyright: GPL
Group: Development/Languages
Source0: gcc-%{version}-%{DATE}.tar.bz2
Source1: libgcc_post_upgrade.c
URL: http://gcc.gnu.org
BuildRoot: /var/tmp/gcc-root
# Need binutils with -pie support >= 2.14.90.0.4-4
# Need binutils which can omit dot symbols and overlap .opd on ppc64
BuildRequires: binutils >= 2.15.91.0.2-4
# Need binutils with -pie support
# Need --as-needed/--no-as-needed support
# On ppc64, need omit dot symbols support and --non-overlapping-opd
%ifarch ppc ppc64
Requires: binutils >= 2.15.91.0.2-4
%else
Requires: binutils >= 2.15.90.0.1.1-2
%endif
BuildRequires: zlib-devel, gettext, dejagnu, bison, flex, texinfo
# Make sure pthread.h doesn't contain __thread tokens
BuildRequires: glibc-devel >= 2.2.90-12
# Need .eh_frame ld optimizations
# Need proper visibility support
# Need -pie support
Requires: binutils >= 2.14.90.0.4-4
# Make sure gdb will understand DW_FORM_strp
Conflicts: gdb < 5.1-2
Requires: glibc-devel >= 2.2.90-12
Requires: libgcc >= 3.3.2-7
Prereq: /sbin/install-info
AutoReq: true
Obsoletes: gcc35

Patch1: gcc4-ice-hack.patch
Patch2: gcc4-ppc64-m32-m64-multilib-only.patch
Patch3: gcc4-ia64-noteGNUstack.patch
Patch4: gcc4-makej.patch
Patch5: gcc4-range-enum.patch
Patch6: gcc4-java-bytecode.patch
Patch7: gcc4-libjava-jar-timestamps.patch
Patch8: gcc4-ppc64-killdotsyms2.patch
Patch9: gcc4-ia64-libunwind.patch
Patch10: gcc4-stdarg.patch
Patch11: gcc4-chk.patch
Patch12: gcc4-ppc64-pr17751.patch
Patch13: gcc4-gnuc-rh-release.patch
Patch14: gcc4-builtin-mathfn-save.patch

%define _gnu %{nil}
%ifarch sparc
%define gcc_target_platform sparc64-%{_vendor}-%{_target_os}
%endif
%ifarch ppc
%define gcc_target_platform ppc64-%{_vendor}-%{_target_os}
%endif
%ifnarch sparc ppc
%define gcc_target_platform %{_target_platform}
%endif

%description
The gcc4 package contains preview of the GNU Compiler Collection version 4.0.

%package c++
Summary: C++ support for GCC version 4.0 preview
Group: Development/Languages
Requires: gcc4 = %{version}-%{release}
Requires: libstdc++ = %{gxx_primary_version}
Requires: libstdc++-devel = %{gxx_primary_version}
Autoreq: true
Obsoletes: gcc35-c++

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

%package gfortran
Summary: Fortran 95 support
Group: Development/Languages
Requires: gcc4 = %{version}-%{release}
Requires: libgfortran = %{version}-%{release}
Prereq: /sbin/install-info
Autoreq: true
Obsoletes: gcc35-gfortran

%description gfortran
The gcc4-gfortran package provides a preview of Fortran 95
compiler from the GNU Compiler Collection.

%package -n libgfortran
Summary: Fortran 95 runtime
Group: System Environment/Libraries
Autoreq: true

%description -n libgfortran
This package contains Fortran 95 shared library which is needed to run
dynamically linked programs created with the Fortran 95 preview
compiler.

%package -n libmudflap
Summary: GCC mudflap shared support library
Group: System Environment/Libraries

%description -n libmudflap
This package contains GCC shared support library which is needed
for mudflap support.

%package -n libmudflap-devel
Summary: GCC mudflap support
Group: Development/Libraries
Requires: libmudflap = %{version}-%{release}
Requires: gcc4 = %{version}-%{release}

%description -n libmudflap-devel
This package contains headers and static libraries for building
mudflap-instrumented programs.

To instrument a non-threaded program, add -fmudflap
option to GCC and when linking add -lmudflap, for threaded programs
also add -fmudflapth and -lmudflapth.

%prep
%setup -q -n gcc-%{version}-%{DATE}
%patch1 -p0 -b .ice-hack~
%patch2 -p0 -b .ppc64-m32-m64-multilib-only~
%patch3 -p0 -b .ia64-noteGNUstack~
%patch4 -p0 -b .makej~
%patch5 -p0 -b .range-enum~
%patch6 -p0 -b .java-bytecode~
%patch7 -p0 -b .libjava-jar-timestamps~
%patch8 -p0 -b .ppc64-killdotsyms2~
%patch9 -p0 -b .ia64-libunwind.patch~
%patch10 -p0 -b .stdarg~
%patch11 -p0 -b .chk~
%patch12 -p0 -b .ppc64-pr17751~
%patch13 -p0 -b .gnuc-rh-release~
%patch14 -p0 -b .builtin-mathfn-save~

perl -pi -e 's/4\.0\.0/4.0.0/' gcc/version.c
perl -pi -e 's/"%{gcc_version}"/"%{gcc_version} \(release\)"/' gcc/version.c
perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(Red Hat %{version}-%{gcc_release}\)/' gcc/version.c

cp -a libstdc++-v3/config/cpu/i{4,3}86/atomicity.h

# Hack to avoid building multilib libjava
perl -pi -e 's/^all: all-redirect/ifeq (\$(MULTISUBDIR),)\nall: all-redirect\nelse\nall:\n\techo Multilib libjava build disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^install: install-redirect/ifeq (\$(MULTISUBDIR),)\ninstall: install-redirect\nelse\ninstall:\n\techo Multilib libjava install disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^check: check-redirect/ifeq (\$(MULTISUBDIR),)\ncheck: check-redirect\nelse\ncheck:\n\techo Multilib libjava check disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^all: all-recursive/ifeq (\$(MULTISUBDIR),)\nall: all-recursive\nelse\nall:\n\techo Multilib libjava build disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^install: install-recursive/ifeq (\$(MULTISUBDIR),)\ninstall: install-recursive\nelse\ninstall:\n\techo Multilib libjava install disabled\nendif/' libjava/Makefile.in
perl -pi -e 's/^check: check-recursive/ifeq (\$(MULTISUBDIR),)\ncheck: check-recursive\nelse\ncheck:\n\techo Multilib libjava check disabled\nendif/' libjava/Makefile.in

# As I'm not sure if GCC 4.0 release's libgfortran.so will not stay at libgfortran.so.0,
# and most probably this libgfortran.so will be binary incompatible with the final one,
# rename it.
perl -pi -e 'm/FORTRAN_LIBRARY/ && s/-lgfortran/-lgfortranpreview/' gcc/fortran/gfortranspec.c
perl -pi -e 's/libgfortran(\.la|_la|inc|\.a)/libgfortranpreview$1/g' libgfortran/Makefile.am libgfortran/Makefile.in gcc/testsuite/lib/gfortran.exp

./contrib/gcc_update --touch

%build

rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  mkdir locale
  localedef -f ISO-8859-1 -i de_DE locale/de_DE
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g;s/-m32//g;s/-m31//g'`
%ifarch sparc sparc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g'`
%endif
%ifarch %{ix86}
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-mcpu=/-mtune=/g'`
%endif
%ifarch sparc64
cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
chmod +x gcc64
CC=`pwd`/gcc64
%endif
%ifarch ppc64
if gcc -m64 -xc -S /dev/null -o - > /dev/null 2>&1; then
  cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
  chmod +x gcc64
  CC=`pwd`/gcc64
fi
%endif
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	GCJFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--enable-shared --enable-threads=posix --enable-checking=release \
	--with-system-zlib --enable-__cxa_atexit --disable-libunwind-exceptions \
	--with-gxx-include-dir=/usr/include/c++/%{gxx_primary_version} \
	--enable-languages=c,c++,f95 \
	--disable-libgcj \
%ifarch sparc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=v7
%endif
%ifarch ppc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=default32
%endif
%ifnarch sparc ppc
	--host=%{gcc_target_platform}
%endif

#make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" bootstrap
%ifarch noarch
# %{ix86} x86_64
make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" profiledbootstrap
%else
make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" bootstrap-lean
%endif

# run the tests.
LC_ALL=C make %{?_smp_mflags} -k check || :
LC_ALL=C make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi-verbose || :
( ../contrib/test_summary -t || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}' > testresults
mv gcc/testsuite{,.prev}
LC_ALL=C make %{?_smp_mflags} RUNTESTFLAGS="compat.exp ALT_CC_UNDER_TEST=gcc ALT_CXX_UNDER_TEST=g++" check-gcc check-g++ || :
mv gcc/testsuite/gcc.sum{,.sent}
mv gcc/testsuite/g++.sum{,.sent}
( ../contrib/test_summary -o -t || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}' > testresults2
echo ====================TESTING=========================
cat testresults
echo ===`gcc --version | head -1` compatibility tests====
cat testresults2
LC_ALL=C make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi || :
echo ====================TESTING END=====================
#cd %{gcc_target_platform}/libstdc++-v3
#./mkcheck 0
#cd ../..

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/gfortran

(cd gcc/fortran; for i in ChangeLog* CONTRIB NEWS README TODO; do
	cp -p $i ../../rpm.doc/gfortran/$i.f
done)
(cd libgfortran; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/gfortran/$i.libgfortran
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)

%install
rm -fr $RPM_BUILD_ROOT

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/docs/html/documentation.html
ln -sf documentation.html libstdc++-v3/docs/html/index.html
find libstdc++-v3/docs/html -name CVS | xargs rm -rf

cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

TARGET_PLATFORM=%{gcc_target_platform}

# There are some MP bugs in libstdc++ Makefiles
make -C %{gcc_target_platform}/libstdc++-v3

make DESTDIR=$RPM_BUILD_ROOT install

FULLPATH=$RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
FULLEPATH=$RPM_BUILD_ROOT%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}

# fix some things
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/cc
mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ..%{_prefix}/bin/cpp $RPM_BUILD_ROOT/lib/cpp
ln -sf gfortran $RPM_BUILD_ROOT%{_prefix}/bin/f95
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*

cxxconfig="`find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h`"
for i in `find %{gcc_target_platform}/[36]*/libstdc++-v3/include -name c++config.h 2>/dev/null`; do
  if ! diff -up $cxxconfig $i; then
    cat > $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform}/bits/c++config.h <<EOF
#ifndef _CPP_CPPCONFIG_WRAPPER
#define _CPP_CPPCONFIG_WRAPPER 1
#include <bits/wordsize.h>
#if __WORDSIZE == 32
%ifarch %{multilib_64_archs}
`cat $(find %{gcc_target_platform}/32/libstdc++-v3/include -name c++config.h)`
%else
`cat $(find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h)`
%endif
#else
%ifarch %{multilib_64_archs}
`cat $(find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h)`
%else
`cat $(find %{gcc_target_platform}/64/libstdc++-v3/include -name c++config.h)`
%endif
#endif
#endif
EOF
    break
  fi
done

%ifarch sparc ppc
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/%{_target_platform}-gcc
%endif
%ifarch sparc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif
%ifarch ppc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc
%endif

%ifarch sparc ppc
FULLLPATH=$FULLPATH/lib32
%endif
%ifarch sparc64 ppc64
FULLLPATH=$FULLPATH/lib64
%endif
if [ -n "$FULLLPATH" ]; then
  mkdir -p $FULLLPATH
else
  FULLLPATH=$FULLPATH
fi

mkdir -p $RPM_BUILD_ROOT/%{_lib}
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
chmod 755 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
ln -sf libgcc_s-%{gcc_version}-%{DATE}.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.1
ln -sf /%{_lib}/libgcc_s.so.1 $FULLPATH/libgcc_s.so
%ifarch sparc ppc
ln -sf /lib64/libgcc_s.so.1 $FULLPATH/libgcc_s_64.so
%endif
%ifarch %{multilib_64_archs}
ln -sf /lib/libgcc_s.so.1 $FULLPATH/libgcc_s_32.so
%endif

LIBSTDCXX_SUFFIX=6.$(ls -l `gcc -print-file-name=libstdc++.so` | sed 's,^.*-> .*/libstdc++\.so\.6\.,,')
pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libstdc++.so.$LIBSTDCXX_SUFFIX libstdc++.so
ln -sf ../../../libgfortranpreview.so.0.* libgfortranpreview.so
ln -sf ../../../libmudflap.so.0.* libmudflap.so
ln -sf ../../../libmudflapth.so.0.* libmudflapth.so
else
ln -sf ../../../../%{_lib}/libstdc++.so.$LIBSTDCXX_SUFFIX libstdc++.so
ln -sf ../../../../%{_lib}/libgfortranpreview.so.0.* libgfortranpreview.so
ln -sf ../../../../%{_lib}/libmudflap.so.0.* libmudflap.so
ln -sf ../../../../%{_lib}/libmudflapth.so.0.* libmudflapth.so
fi
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libstdc++.*a $FULLLPATH/
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libsupc++.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgfortranpreview.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgfortranbegin.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libmudflap{,th}.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/include/mf-runtime.h include/

%ifarch sparc ppc
ln -sf ../`echo ../../../../lib/libstdc++.so.$LIBSTDCXX_SUFFIX | sed s~/lib/~/lib64/~` 64/libstdc++.so
ln -sf ../`echo ../../../../lib/libgfortranpreview.so.0.* | sed s~/lib/~/lib64/~` 64/libgfortranpreview.so
ln -sf ../`echo ../../../../lib/libmudflap.so.0.* | sed s~/lib/~/lib64/~` 64/libmudflap.so
ln -sf ../`echo ../../../../lib/libmudflapth.so.0.* | sed s~/lib/~/lib64/~` 64/libmudflapth.so
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libsupc++.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libgfortranpreview.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libgfortranbegin.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libmudflap{,th}.*a 64/
#ln -sf lib32/libstdc++.a libstdc++.a
#ln -sf ../lib64/libstdc++.a 64/libstdc++.a
ln -sf ../%{gxx_primary_version}/lib32/libstdc++.a libstdc++.a
ln -sf ../../%{gxx_primary_version}/lib64/libstdc++.a 64/libstdc++.a
%endif
%ifarch %{multilib_64_archs}
mkdir -p 32
ln -sf ../`echo ../../../../lib64/libstdc++.so.$LIBSTDCXX_SUFFIX | sed s~/../lib64/~/~` 32/libstdc++.so
ln -sf ../`echo ../../../../lib64/libgfortranpreview.so.0.* | sed s~/../lib64/~/~` 32/libgfortranpreview.so
ln -sf ../`echo ../../../../lib64/libmudflap.so.0.* | sed s~/../lib64/~/~` 32/libmudflap.so
ln -sf ../`echo ../../../../lib64/libmudflapth.so.0.* | sed s~/../lib64/~/~` 32/libmudflapth.so
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libsupc++.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgfortranpreview.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgfortranbegin.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libmudflap{,th}.*a 32/
%endif
%ifarch sparc64 ppc64
#ln -sf ../lib32/libstdc++.a 32/libstdc++.a
#ln -sf lib64/libstdc++.a libstdc++.a
ln -sf ../../%{gxx_primary_version}/lib32/libstdc++.a 32/libstdc++.a
ln -sf ../%{gxx_primary_version}/lib64/libstdc++.a libstdc++.a
%else
%ifarch %{multilib_64_archs}
#ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libstdc++.a 32/libstdc++.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gxx_primary_version}/libstdc++.a 32/libstdc++.a
%endif
%endif
%ifnarch sparc ppc sparc64 ppc64
ln -sf ../%{gxx_primary_version}/libstdc++.a libstdc++.a
%endif

# Strip debug info from Fortran/ObjC/Java static libraries
strip -g `find . \( -name libgfortranpreview.a -o -name libobjc.a -o -name libgcj.a \
		    -o -name lib-org-w3c-dom.a -o -name lib-org-xml-sax.a \
		    -o -name libmudflap.a -o -name libmudflapth.a \
		    -o -name libgcc.a -o -name libgcov.a \) -a -type f`
popd
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgfortranpreview.so.0.*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libmudflap{,th}.so.0.*

for h in `find $FULLPATH/include -name \*.h`; do
  if grep -q 'It has been auto-edited by fixincludes from' $h; then
    rh=`grep -A2 'It has been auto-edited by fixincludes from' $h | tail -1 | sed 's|^.*"\(.*\)".*$|\1|'`
    diff -up $rh $h || :
    rm -f $h
  fi
done

cat > $RPM_BUILD_ROOT%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
cat > $RPM_BUILD_ROOT%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c?9

mkdir -p $RPM_BUILD_ROOT%{_prefix}/sbin
gcc -static -Os %{SOURCE1} -o $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade
strip $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade

cd ..

for i in $RPM_BUILD_ROOT%{_prefix}/bin/{*gcc,*++,gcov}; do
  mv -f $i ${i}4
done

# Remove binaries we will not be including, so that they don't end up in
# gcc4-debuginfo
rm -f $RPM_BUILD_ROOT%{_prefix}/bin/{c++4,c89,c99,cpp,gccbug,*-linux-gcc-3*,*-linux-gcj,*-linux-gcjh,protoize,unprotoize}
rm -f $RPM_BUILD_ROOT%{_lib}/libgcc_s-3*
rm -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/{libffi*,libiberty.a,libstdc++*}
rm -f $FULLEPATH/{cc1obj,install-tools/{mkheaders,fixincl}}
rm -f $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade
%ifarch %{multilib_64_archs}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/{lib-org*,libffi*,libiberty.a,libstdc++*}
%endif
%ifarch sparc ppc
rm -rf $RPM_BUILD_ROOT%{_prefix}/lib/64
rm -f $RPM_BUILD_ROOT%{_prefix}/lib64/{lib-org*,libffi*,libiberty.a,libstdc++*}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post gfortran
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gfortran.info.gz

%preun gfortran
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gfortran.info.gz
fi

%post -n libgfortran -p /sbin/ldconfig

%postun -n libgfortran -p /sbin/ldconfig

%post -n libmudflap -p /sbin/ldconfig

%postun -n libmudflap -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_prefix}/bin/gcc4
%{_prefix}/bin/gcov4
%ifarch sparc ppc
%{_prefix}/bin/%{_target_platform}-gcc4
%endif
%ifarch sparc64
%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc4
%endif
%ifarch ppc64
%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc4
%endif
%{_prefix}/bin/%{gcc_target_platform}-gcc4
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/syslimits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/unwind.h
%ifarch %{ix86} x86_64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/xmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/emmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/pmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm_malloc.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mm3dnow.h
%endif
%ifarch ia64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif
%ifarch ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ppc-asm.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/altivec.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/spe.h
%endif
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/README
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/collect2
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s_64.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s_32.so
%endif
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/specs
%doc gcc/README* gcc/*ChangeLog* gcc/COPYING gcc/COPYING.LIB

%files c++
%defattr(-,root,root)
%{_prefix}/bin/%{gcc_target_platform}-*++4
%{_prefix}/bin/g++4
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1plus
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libsupc++.a
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libsupc++.a
%endif
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%doc gcc/cp/ChangeLog*

%files gfortran
%defattr(-,root,root)
%{_prefix}/bin/gfortran
%{_mandir}/man1/gfortran.1*
%{_infodir}/gfortran*
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/f951
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortranpreview.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgfortranpreview.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortranpreview.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgfortranpreview.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortranbegin.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortranpreview.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgfortranpreview.so
%endif
%doc rpm.doc/gfortran/*

%files -n libgfortran
%defattr(-,root,root)
%{_prefix}/%{_lib}/libgfortranpreview.so.0*

%files -n libmudflap
%defattr(-,root,root)
%{_prefix}/%{_lib}/libmudflap.so.0*
%{_prefix}/%{_lib}/libmudflapth.so.0*

%files -n libmudflap-devel
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mf-runtime.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libmudflapth.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libmudflapth.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflap.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflapth.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflap.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libmudflapth.so
%endif
%doc libmudflap/ChangeLog*

%changelog
* Tue Dec 14 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.14.EL4
- update from trunk
  - fix tree inlining related ICE (Alexandre Oliva, #141145)
- avoid multiple evaluation of sqrt and other math builtins when
  not -ffast-math (#142603, PR middle-end/18951)

* Tue Dec  7 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.14
- update from trunk
  - fix DEPENDENCIES_OUTPUT handling (#140921)
- fix libstdc++.so symlinks (#141985)
- make sure target's LOAD_EXTEND_OP or lack thereof doesn't influence
  gcj -C output (#141730)

* Sat Nov 27 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.13
- update from trunk
  - change s390{,x} stack layout to work-around GCC 2.95.3 bug:
    former -mno-backchain (the default), -mbackchain and -mkernel-backchain
    options were transformed into (in order) -mno-backchain -mpacked-stack,
    -mbackchain -mno-packed-stack and -mbackchain -mpacked-stack.
    A new combination -mno-backchain -mno-packed-stack is now the
    new default (Andreas Krebbel, #139678)
- don't optimize printf/fprintf/__printf_chk/__fprintf_chk in any way
  if return value is not ignored
- some more libgcc_s.so.1 tweaks on ia64

* Fri Nov 12 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.12
- update from trunk
- make _Unwind_* symbols in libgcc_s.so.1 unversioned to match the
  "IA-64 Linux ABI"

* Mon Nov  8 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.11
- use/require GCC 3.4.3 instead of 3.4.2

* Sun Nov  7 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.10
- update from trunk
- add %%doc COPYING and COPYING.LIB

* Thu Oct 28 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.9
- update from trunk
- run testsuite with LC_ALL=C

* Tue Oct 19 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.8
- update from trunk
- make sure .toc{,1} sections are created on ppc -m64 -mminimal-toc
  (#134248, PR target/17751)
- define __GNUC_RH_RELEASE__ macro to match %%{gcc_release} rpm macro
  (well, its first number)

* Sat Oct 16 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.7
- added object size checking patch
- added stdarg optimization patch

* Sat Oct 16 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.6
- update from trunk

* Fri Oct  8 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.5
- update from trunk
  - fix ppc64 bootstrap (Michael Matz)

* Fri Oct  8 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.4
- update from trunk
- call /sbin/ldconfig in libgfortran and libmudflap %%post{,un} (#134067)
- obsolete gcc35-gfortran (#134810)
- re-enable COMDAT

* Tue Sep 28 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.3
- update from trunk

* Mon Sep 20 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.2
- update from trunk
- add .note.GNU-stack marking to ppc64 crtsavres.o and
  ia64 crt{begin,end,i,n}.o
- gimplify folded builtins during fold_all_builtins pass
  if they aren't gimple
- use/require GCC 3.4.2 instead of 3.4.1

* Fri Sep 17 2004 Jakub Jelinek  <jakub@redhat.com> 4.0.0-0.1
- update from trunk
- change version to 4.0.0, as there will be no GCC 3.5
- temporarily disable COMDAT support until at least binutils are upgraded
- temporarily remove the IA-64 libunwind stuff

* Thu Sep  9 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.11
- improve SSA aliasing detection for PTR + OFFSET

* Wed Sep  1 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.10
- update from trunk
- fix x ? (unsigned long) d : (long) d conversion bug for d floating
  (#131082)

* Fri Aug 20 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.9
- fix ppc64 bootstrap (PR rtl-optimization/17099)
- fix libstdc++.so symlinks, include libsupc++.a everywhere
- remove Fortran documentation which accidentally ended up in
  libmudflap-devel, add libmudflap ChangeLog
- add spe.h header on ppc and ppc64, altivec.h and ppc-asm.h on ppc64

* Wed Aug 18 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.8
- update from trunk
- stop using dot symbols on ppc64 (Alan Modra)
- overlap fd_aux field of ppc64 .opd entries with next .opd entry's fd_func
  if a function is not going to use r11 passed to it
- add mm3dnow.h and mm_malloc.h headers on ia32/x86-64
- add gcc35-gfortran, libgfortran subpackages (#130212)
- add libmudflap and libmudflap-devel subpackages

* Thu Jul 15 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.7
- update from trunk
- make even multilib libstdc++.so's versioned

* Fri Jul  9 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.6
- reenable bitfield patch
- fix enum { A, B, C, D, E } if (x == B || x == C || x == D)
  style tests in C++

* Fri Jul  9 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.5
- update from trunk

* Mon Jul  5 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.4
- temporary disable the bitfield patch until it is fixed

* Sat Jul  3 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.3
- update from trunk
- use/require gcc 3.4.1 instead of 3.4.0

* Tue Jun 29 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.2
- optimize some bitfield operations (PR tree-optimization/15310)

* Thu Jun 24 2004 Jakub Jelinek  <jakub@redhat.com> 3.5.0-0.1
- initial package
